/*-----------------------------------------------------------------------
/  Low level disk interface modlue include file  R0.02    (C)ChaN, 2006
/-----------------------------------------------------------------------*/

#ifndef _DISKIF

//#define _READONLY	/* Define this for read-only use */

#include "integer.h"

typedef unsigned char	DSTATUS;
typedef unsigned char	DRESULT;


/*---------------------------------------*/
/* Prototypes for disk control functions */
DSTATUS disk_shutdown ();
extern DSTATUS disk_initialize (BYTE);
extern DSTATUS disk_status (BYTE);
extern DRESULT disk_read (BYTE, BYTE*, DWORD, BYTE);

extern DRESULT disk_write (BYTE, const BYTE*, DWORD, BYTE);

extern DRESULT disk_ioctl (BYTE, BYTE, void*);
void	disk_timerproc (void);


/* Results of Disk Functions (DRESULT) */

#define RES_OK			0		/* Successful */
#define	RES_ERROR		1		/* R/W Error */
#define	RES_WRPRT		2		/* Write Protected */
#define	RES_NOTRDY		3		/* Not Ready */
#define	RES_PARERR		4		/* Invalid Parameter */


/* Disk Status Bits (DSTATUS) */

#define STA_NOINIT		0x01	/* Drive not initialized */
#define STA_NODISK		0x02	/* No medium in the drive */
#define STA_PROTECT		0x04	/* Write protected */


/* Command code for disk_ioctrl() */

#define PUT_IDLE_STATE	        2

#define ATA_GET_REV		20
#define ATA_GET_MODEL	        21
#define ATA_GET_SN		22

/* Generic command */
#define CTRL_SYNC		0			/* Mandatory for write functions */
#define GET_SECTOR_COUNT	1			/* Mandatory for only f_mkfs() */
#define GET_SECTOR_SIZE		2
#define GET_BLOCK_SIZE		3			/* Mandatory for only f_mkfs() */
#define CTRL_POWER	        4
#define CTRL_LOCK	        5
#define CTRL_EJECT	        6

/* MMC/SDC command */
#define MMC_GET_TYPE		10
#define MMC_GET_CSD		11
#define MMC_GET_CID		12
#define MMC_GET_OCR		13
#define MMC_GET_SDSTAT		14

#define _DISKIF
#endif
